#!/usr/bin/perl

use strict;
use warnings "all";

if (!defined($ARGV[1])) {
	print STDERR "po_clean_log.pl LOGFILE OUTFILE >CLEAN_LOGFILE\nThe proteinortho logfile contains all blast alignments.\nHowever, some were removed in the proteinotho graph\nThis script removes the edges from the logfile so it\nmatches the internal graph of proteinortho\n";
	exit;
}

# Proteinortho Output
my %name_id;
my @member;
my $sharp = 0;
open(LOG,"<$ARGV[0]") || die("Could not open file $ARGV[0]: $!");
while (<LOG>) {
	chomp;
	if ($_ =~ /^#species/) {$sharp = 1; print "$_\n"; next;}
	if ($sharp == 1) {
		print "$_\n";
		if ($_ =~ /^#protein_a/) {
			$sharp = 2;
			## Load set
			my $counter = 0;
			open(OUT,"<$ARGV[1]") || die("Could not open file $ARGV[0]: $!");
			while (<OUT>) {
				chomp;
				if ($_ =~ /^#/) {next;}
				$counter++;
				# 13	14	0.132	jgi|Agabi_varbisH97_2|175561|estExt_fgenesh2_pg.C_10002	jgi|Conpu1|87220|fgenesh1_pm.1_#_1100	jgi|Fomme1|95786|e_gw1.15.108.1	jgi|Hetan2|153488|Hetan1.estExt_fgenesh2_pm.C_10011	jgi|Jaaar1|72523|estExt_fgenesh1_pm.C_250106	jgi|Lacbi2|182804|Lacbi1.estExt_GeneWisePlus_human.C_30653	jgi|Lepmu1|11216|Lema_T071270.1	jgi|Phchr1|135447|e_gww2.13.20.1	jgi|PleosPC15_2|1076748|fgenesh1_pm.05_#_248	jgi|Pospl1|118833|estExt_Genewise1.C_1410033,jgi|Pospl1|127984|estExt_fgenesh3_pg.C_1090060	jgi|Schco1|72893|estExt_Genewise1.C_12497	jgi|SerlaS7_3_2|171912|estExt_fgenesh1_pm.C_180038	jgi|Stehi1|101315|estExt_Genewise1Plus.C_13_t10071
				my (@data) = split(/\s+/,$_);
				for (my $i = 3; $i < scalar(@data); $i++) {
					foreach my $protein (split(/,/,$data[$i])) {
						if ($protein eq "*") {next;}
						unless (defined($name_id{$protein})) {die("$protein was not introduced\n");}
						$member[$name_id{$protein}] = $counter;
					}
				}
			}
			close(OUT);
			next;
		}
		my ($species, $protein, $id) = split(/\s+/,$_);
		$name_id{$protein} = $id;
	}
	elsif ($sharp == 2) {
		# protein_a	protein_b	E-value a2b	bit score a2b	E-value b2a	bit score b2a
		my ($a,$b,$val) = split(/\s+/,$_,3);
		if (!defined($member[$a])) {next;}
		if (!defined($member[$b])) {next;}
		if ($member[$a] == $member[$b]) {print $_."\n";}
	}
}
close(LOG);
